<%
' Global Variables and constants

	' ===================================================
	' Name: Global Variables (globalvars.asp)
	' Version: 1.0.0
	' Date: 20/2/2004
	' Author: Ezzat A. Helal (eahelal@helalsoftware.net)
	' Web Site: www.helalsoftware.net
	' Description: Defines and initializes global variables and constants used by the application
	' =====================================================================================
	' =====================================================================================
	' This is free software. you can use is in any application or even modify it but with only one restriction:
	' Do not remove these comment lines and send me a notification via email. Thank You.
	' ===================================================================================
' ============================================ ErrorCodes
Const ted_version = "1.1.1"
Const database_name = "oosDb.mdb"
Const ted_browse_image = True
Const ted_image_directory = "orphanpic/"
Const ted_image_width = 100
Const ted_image_height = 100
Const ted_date_format = "dd/mm/yyyy"
Const muti_sponsorship = True
' muti_sponsorship = True if one child can be sponsored by more than one sponsor. In this case
' All orphans in the orphans file will be shown in the search page. Otherwise the orphans shown
' for search are those who are not sponsored by any sponsor.

Public Const hshNumIMF = 1  ' Total Number of image fields
Public ted_image_fields(1)
ted_image_fields(0) = "orphan|PictureDir"  ' table_name|field_name

Public hshErrCode, hshErrDesc 
' = 0 No Error
' = 1 EOF or BOF
' = 2 Record Not Found
' = 3 Invalid Field
' = 4 Duplicate Records
' = 5 Key Field is null
' = 6 Connection Error
' = 7 No records selected for deletion
' = 8 No ISN field found in Records specifications
' = 9 Syntax Error in GlobalVars specs
' ============================================== hshUniqueKeyFields
'  (changed for different application) =========================
'  Specification of a composit unique key for the table
'	Format First field (*table_name) astrisk followed by table name
'		Following fields specify the unique key fields each one in a 
'		separate array item containg the name of the field.
'	hshNumUKF is the total number of array items.
'	hshUniqueKeyFields is the array of unique keys specification
' =======================================================================
Public hshUniqueKeyFields()
Public Const hshNumUKF = 11
ReDim hshUniqueKeyFields(11)

hshUniqueKeyFields(0) = "*2user"
hshUniqueKeyFields(1) = "userName|userPassword"
hshUniqueKeyFields(2) = "email"
' ------------------------------------
hshUniqueKeyFields(3) = "*1sponsorship"
If muti_sponsorship = True Then
	hshUniqueKeyFields(4) = "sponsorLNKi1|Orphan"
Else
	hshUniqueKeyFields(4) = "Orphan"
End If
' ------------------------------------
hshUniqueKeyFields(5) = "*1sponsor"
hshUniqueKeyFields(6) = "email"
' ------------------------------------
hshUniqueKeyFields(7) = "*1orphan"
hshUniqueKeyFields(8) = "orphanISN"
' ------------------------------------
hshUniqueKeyFields(9) = "*1Invoice"
hshUniqueKeyFields(10) = "Invoice_Number|Invoice_Issue_Date"

' ============================================== hshReadOnlyFields
'  (changed for different application) =========================
'  Specification of Read Only Fields for the table
'	Format First field (*ntable_name) astrisk followed by number of fields (n) and table name
'		Following fields specify the read only fields each one in a 
'		separate array item containg the name of the field and the default value in case of addition.
'	hshNumROF is the total number of array items.
'	hshReadOnlyFields is the array of Read Only specification
' =======================================================================
Public hshReadOnlyFields()
Public Const hshNumROF = 3
ReDim hshReadOnlyFields(3)

hshReadOnlyFields(0) = "*2user"
hshReadOnlyFields(1) = "LastVisitDate|NOW"
hshReadOnlyFields(2) = "VisitCount|0"
' ------------------------------------
' ============================================= Link Fields
' (Changed for different applications =====================
' Format table: *n*tableName Where n is the number of linked fields in the table
'		 Field: FieldName|LinkedTableName
'	LinkedTableName must specified in the following Array (Linked Tables)
' ===============================================================================	
Public hshLinkedFields()
Public Const hshNumLF = 9
ReDim hshLinkedFields(9)
hshLinkedFields(0) = "*3*orphan"
hshLinkedFields(1) = "Gender|gender"
hshLinkedFields(2) = "Disabled|DisableCodes"
hshLinkedFields(3) = "countryLnk|country"
hshLinkedFields(4) = "*2*sponsorship"
hshLinkedFields(5) = "sponsorLNKi1|sponsor"
hshLinkedFields(6) = "Orphan|orphan"
hshLinkedFields(7) = "*1*Invoice"
hshLinkedFields(8) = "sponsorLNK|sponsor"

' ============================================= Linked Tables
' (Changed for different applications =====================
'	First Item table name preceeded by astrisk
'	second item specify the code field name
'	third item specify the description field name 
'		(if cocatenated field use the separator (+) between fields).
Public hshLinkedTables()
Public Const hshNumLT = 15
ReDim hshLinkedTables(15)
hshLinkedTables(0) = "*gender"
hshLinkedTables(1) = "genderISN"
hshLinkedTables(2) = "genderName"
' ----------------------------------
hshLinkedTables(3) = "*DisableCodes"
hshLinkedTables(4) = "Disabled"
hshLinkedTables(5) = "DisableDesc"
' ---------------------------------
hshLinkedTables(6) = "*orphan"
hshLinkedTables(7) = "orphanISN"
hshLinkedTables(8) = "First_Name+Middle_Name+Family_Name"
' ---------------------------------
hshLinkedTables(9) = "*sponsor"
hshLinkedTables(10) = "sponsorISN"
hshLinkedTables(11) = "first_name+middle_name+last_name"
' ---------------------------------
hshLinkedTables(12) = "*country"
hshLinkedTables(13) = "countryISN"
hshLinkedTables(14) = "countryName"

' =========================================== Keywords
Public Keywords()
Public Const NumKeywords = 11
redim Keywords(15)

Keywords(0) = "Group"
Keywords(1) = "Select"
Keywords(2) = "Where"
Keywords(3) = "Order"
Keywords(4) = "Insert"
Keywords(5) = "Update"
Keywords(6) = "From"
Keywords(7) = "By"
Keywords(8) = "user"	
Keywords(9) = "userName"	
Keywords(10) = "userPassword"	

' ====================================================
' Customized function for the application
' These functions are used by tablefun.asp and should be custumized for each application.
' The code here is for OOS (Online Orphan Sponsorship)
' The first two functions for updating related tables when a table is updated (Add, Edit, or Delete)
' The third function for updating related table when a record is deleted in a table.
' =====================================================================
' Get old field value for updated table
' ====================================================================
Function Set_Old_ISN(TableName, rs)
	If TableName = "sponsorship" Then
		Set_Old_ISN = CLng(rs("Orphan"))
	Else
		Set_Old_ISN = 0
	End If
End Function

' =================================================
' hsh_After_Update
' ================================================
Function hsh_After_Update(strTableName, oldISN, recISN)
	Dim dbConn, sqlQry, cmd, rs

	hshErrCode = 0
	If strTableName = "sponsorship" Then
		' =========================================================================
		' Switch IsSponsored in orphan table to True
		Set dbConn = Server.CreateObject("ADODB.Connection")
		call hsh_OpenConnection(dbConn, database_name)
		set cmd = Server.CreateObject("ADODB.Command")
		cmd.ActiveConnection = dbConn
		If recISN > 0 Then
			'sqlQry = "Select Orphan From sponsorship Where (sponsorshipISN = " & recISN & ")"
			'Set rs = Server.CreateObject("ADODB.Recordset")
			'rs.Open sqlQry, dbConn
			'If Not rs.EOF Then
				sqlQry = "Update Orphan Set IsSponsored = -1 Where (orphanISN=" & recISN & ")"
			'Response.Write("sql: " & sqlQry)
				cmd.CommandText = sqlQry
				cmd.Execute 
			'End If
			'rs.Close
			'set rs = Nothing
		End If
		If oldISN > 0 Then
			' Switch IsSponsored in orphan table to False
			sqlQry = "Update Orphan Set IsSponsored = 0 Where (orphanISN=" & oldISN & ")"
			'Response.Write("sql: " & sqlQry)
			cmd.CommandText = sqlQry
			cmd.Execute 
		End If
		call hsh_CloseConnection(dbConn)
		' =========================================================================
	End If
	hsh_After_Update = hshErrCode
	
End Function
' =================================================
' hshOnDelete
' ================================================
Function hshOnDelete(strTableName, rs)
	Dim dbConn, sqlQry, cmd

	hshErrCode = 0
	If strTableName = "orphan" Then
		Dim orphanISN
		orphanISN = CLng(rs("orphanISN"))
		' =========================================================================
		' Delete Related record in sponsorship
		' =========================================================================
		Set dbConn = Server.CreateObject("ADODB.Connection")
		call hsh_OpenConnection(dbConn, database_name)
		sqlQry = "Delete From [sponsorship] Where (Orphan=" & orphanISN & ")"
		set cmd = Server.CreateObject("ADODB.Command")
		cmd.ActiveConnection = dbConn
		cmd.CommandText = sqlQry
		cmd.Execute 
		call hsh_CloseConnection(dbConn)
	ElseIf strTableName = "sponsor" Then
		Dim sponsorISN
		sponsorISN = CLng(rs("sponsorISN"))
		' =========================================================================
		' Delete Related record in sponsorship
		' =========================================================================
		Set dbConn = Server.CreateObject("ADODB.Connection")
		call hsh_OpenConnection(dbConn, database_name)
		sqlQry = "Delete From [sponsorship] Where (sponsorLNKi1=" & sponsorISN & ")"
		set cmd = Server.CreateObject("ADODB.Command")
		cmd.ActiveConnection = dbConn
		cmd.CommandText = sqlQry
		cmd.Execute 
		call hsh_CloseConnection(dbConn)
	ElseIf strTableName = "sponsorship" Then
		call hsh_After_Update(strTableName, Clng(rs("orphan")), 0)
	End If
	hshOnDelete = hshErrCode
	
End Function

%>
