<!--#include file="globalvars.asp" -->
<%

	' =======================================================================================
	' Name: Tables Functions (tablesfunc.asp)
	' Description: Set of function used to maintain access tables.
	' Requirements: Include globalvars.asp for definition of some global variables.
	' versions ==============
	' version: 1.1.0
	' Date: 07/11/2004
	' Version: 1.0.0
	' Date: 20/2/2004
	' =======================
	' Author: Ezzat A. Helal (eahelal@helalsoftware.net)
	' Web Site: www.helalsoftware.net
	'				==========================================================================
	' Functions   : 
	' 				hsh_CloseConnection(dbConn)
	' 				hsh_CloseConnection(dbConn)
	'				hshFindLinkedTable, IsUniqueKey, hsh_ExtractItem, hshCreateSqlForLinkedTable
	'				Generate_Select_Link, hshGetKeyFieldsList(Not Used)
	'				getISN
	'				hsh_After_Update(strTableName, rs, recISN) - Customized for application
	'				hshOnDelete(strTableName, rs) - Customized for application
	'				hshDisplayRecords
	'				DisplayAddNewRecord, AddNewRecord, hshSelectRecord
	'				hshExtractRecord, hshDisplayEditRecord, hshUpdateSelectedRecord
	'				hshEstablishWhereCnd, hshDeleteSelectedRecords
	'				IsKeyField
	'				==========================================================================
	' Naming Convension: These functions requir some naming convension to tables fields as follows:
	'			each table must contain a field starting with table name followed by the three letters (ISN)
	'			This field is used as primary key to the table (ISN stands for Internal Sequence Number)
	'			Link fields are identified by the three letters (LNK) preceeded by the linked table name.
	'			Keys other than ISN are defined in globalvars.asp to validate uniqueness feature.
	'			Non standard linked fields are defined in globalvars.asp.				
	' =====================================================================================
	' This is free software. you can use is in any application or even modify it but with only one restriction:
	' Do not remove these comment lines and send me a notification via email. Thank You.
	' ===================================================================================

' ============================================================
' Open Connection given a database name
' ============================================================
Function hsh_OpenConnection(dbConn, dbName)
	'Dim conn ' connection to access database
	Dim strDS ' Connection String
	'Set dbConn = Server.CreateObject("ADODB.Connection")
	' Access database
	strDS = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & Server.Mappath("db/" & dbName)
	' SQL Server - Provider=SQLOLEDB.1;Data Source=path to database on server
	'strDS = "Provider=SQLOLEDB.1;Data Source=(local);Initial Catalog=WrsDb;User Id=sa;Password=; "
	dbConn.Open strDS
	'hsh_OpenConnection = dbConn
	
End Function
' =================================================================
' Close Connection to Database
' =================================================================
Function hsh_CloseConnection(dbConn)
	
	dbConn.close
	Set dbConn = Nothing

End Function
' =========================================================
' String To Date
' ==========================================================
Function Date_To_String(date_value, strFormat)
	Dim format_character, intDay, intMonth, intYear, p
	
	If Not IsDate(date_value) Or strFormat = "" Then
		Date_To_String = ""
		Exit Function
	End If
	
	format_character = ""
	If InStr(1, strFormat, " ") > 0 Then
		format_character = " "
	ElseIf InStr(1, strFormat, "/") > 0 Then
		format_character = "/"
	ElseIf InStr(1, strFormat, "-") > 0 Then
		format_character = "-"
	ElseIf InStr(1, strFormat, ",") > 0 Then
		format_character = ","
	ElseIf InStr(1, strFormat, ".") > 0 Then
		format_character = "."
	End If
	If format_character = "" Then
		Date_To_String = ""
		Exit Function
	End If
	intDay = Day(date_value)
	intMonth = Month(date_value)
	intYear = Year(date_value)
	Dim strDateFormat, strFieldFormat, strDateValue, fields_count, strFieldValue
	strDateFormat = strFormat
	strDateValue = ""
	fields_count = 0
	Do While strDateFormat <> ""
		strFieldFormat = hsh_ExtractItem(strDateFormat, format_character)
		If strFieldFormat = "d" Or strFieldFormat = "dd" Then
			If strDateValue <> "" Then
				strDateValue = strDateValue & format_character
			End If
			strFieldValue = CStr(intDay)
			If strFieldFormat = "dd" And Len(strFieldValue) < 2 Then
				strFieldValue = "0" & strFieldValue
			End If
			strDateValue = strDateValue & strFieldValue
			fields_count = fields_count + 1
		ElseIf strFieldFormat = "m" Or strFieldFormat = "mm" Then
			If strDateValue <> "" Then 
				strDateValue = strDateValue & format_character
			End If
			strFieldValue = CStr(intMonth)
			If strFieldFormat = "mm" And Len(strFieldValue) < 2 Then
				strFieldValue = "0" & strFieldValue
			End If
			strDateValue = strDateValue & strFieldValue
			fields_count = fields_count + 1
		ElseIf strFieldFormat = "yy" Or strFieldFormat = "yyyy" Then
			fields_count = fields_count + 1
			if intYear < 100 Then
				intYear = 2000 + intYear
			End If
			If strDateValue <> "" Then
				strDateValue = strDateValue & format_character
			End If
			strDateValue =  strDateValue & CStr(intYear)
		End If
	Loop
	If fields_count < 3 Then
		Date_To_String = ""
		Exit Function
	End If
	Date_To_String = strDateValue
	
End Function
' =========================================================
' String To Date
' ==========================================================
Function String_To_Date(strDate, strFormat)
	Dim format_character, intDay, intMonth, intYear, p
	
	If strDate = "" Or strFormat = "" Then
		String_To_Date = 0
		Exit Function
	End If
	
	format_character = ""
	If InStr(1, strFormat, " ") > 0 Then
		format_character = " "
	ElseIf InStr(1, strFormat, "/") > 0 Then
		format_character = "/"
	ElseIf InStr(1, strFormat, "-") > 0 Then
		format_character = "-"
	ElseIf InStr(1, strFormat, ",") > 0 Then
		format_character = ","
	ElseIf InStr(1, strFormat, ".") > 0 Then
		format_character = "."
	End If
	If format_character = "" Then
		String_To_Date = 0
		Exit Function
	End If
	Dim strDateFormat, strFieldFormat, strDateValue, strFieldValue, fields_count
	strDateFormat = strFormat
	strDateValue = strDate
	fields_count = 0
	Do While strDateFormat <> ""
		strFieldFormat = hsh_ExtractItem(strDateFormat, format_character)
		strFieldValue = hsh_ExtractItem(strDateValue, format_character)
		If strFieldFormat = "d" Or strFieldFormat = "dd" Then
			intDay = CInt(Trim(strFieldValue))
			fields_count = fields_count + 1
		ElseIf strFieldFormat = "m" Or strFieldFormat = "mm" Then
			intMonth = CInt(Trim(strFieldValue))
			fields_count = fields_count + 1
		ElseIf strFieldFormat = "yy" Or strFieldFormat = "yyyy" Then
			intYear = CInt(Trim(strFieldValue))
			fields_count = fields_count + 1
			if intYear < 100 Then
				intYear = 2000 + intYear
			End If
		End If
	Loop
	If fields_count < 3 Then
		String_To_Date = 0
		Exit Function
	End If
	String_To_Date = DateSerial(intYear, intMonth, intDay)
	
End Function
' =========================================================
' ImageFieldName
' =========================================================
Function ImageFieldName(table_name)
	Dim k, pos, fldName
	
	fldName = ""
	for k = 0 to hshNumIMF
		pos = InStr(1, ted_image_fields(k), "|")
		if pos > 0 Then
			If table_name = Left(ted_image_fields(k), pos - 1) Then
				fldName = Right(ted_image_fields(k), Len(ted_image_fields(k)) - pos)
				Exit For
			End If
		End If
	Next
	ImageFieldName = fldName
End Function
' =========================================================
' Function hshFindLinkedTable
' ==========================================================
Function hshFindLinkedTable(strTableName, strFieldName)
	Dim i, k, fldCount, fldName, tblName, pos, foundTable
	
	foundTable = ""
	for i = 0 to hshNumLF - 1
		if Mid(hshLinkedFields(i), 1, 1) = "*" then
			pos = InStr(2, hshLinkedFields(i), "*")
			if pos > 0 Then
				If Mid(hshLinkedFields(i), pos+1) = strTableName Then
					fldCount = CInt(Mid(hshLinkedFields(i), 2, pos-2))
					for k = i + 1 to fldCount + i
						pos = InStr(1, hshLinkedFields(k), "|")
						if pos > 0 Then
							fldName = Left(hshLinkedFields(k), pos - 1)
							tblName = Right(hshLinkedFields(k), Len(hshLinkedFields(k)) - pos)
							pos = InStr(1, strFieldName, fldName)
							if pos > 0 Then
								' Linked Field Found Search in Linked Tables
								foundTable = tblName
								Exit For
							End If
						End If
					Next
				End If
			End If
		End If
		If foundTable <> "" Then
			Exit For
		End If
	Next
	hshFindLinkedTable = foundTable
	
End Function
' =====================================================================================
' IsUniqueKey : Check the record for uniqueness in the table and returns true or false
' =====================================================================================
Function IsUniqueKey(TableName, valueList, key_list)
	Dim dbConn, sqlQry, rs, i, fldCount, k, fldName, stPos, endPos, IsFound
	Dim keyFields, strWhere, keyCond(9), maxkeys, curKeyIdx, check_keys, key_Index
	
	hshErrCode = 0
	maxkeys = 9
	For i = 1 to maxkeys
		keyCond(i) = ""
	Next
	strWhere = ""
	If key_list = "" Then
		check_keys = "ALL"
	Else
		check_keys = key_list
	End If
	curKeyIdx = 1
	Set dbConn = Server.CreateObject("ADODB.Connection")
	call hsh_OpenConnection(dbConn, database_name)
	sqlQry = "Select * From [" &  TableName	& "]"

	' Search for unique keys for table [TableName]
	IsFound = True
	for i = 0 to hshNumUKF - 1
		if Mid(hshUniqueKeyFields(i), 1, 1) = "*" then
			If Mid(hshUniqueKeyFields(i), 3) = TableName Then
				fldCount = CInt(Mid(hshUniqueKeyFields(i), 2, 1))
				for k = i + 1 to fldCount + i
					If check_keys = "ALL" Then
						key_Index = k
					Else
						check_keys = key_list
						Do while check_keys <> ""
							key_Index = hsh_ExtractItem(check_keys, ",")
							if key_Index <> "" Then
								key_Index = CInt(key_Index)
								If k = key_Index Then
									Exit Do
								Else
									key_Index = 0
								End If
							Else
								key_Index = 0
								Exit Do
							End If
						Loop
					End If
					If k = key_Index Then
						keyFields = hshUniqueKeyFields(k)
						Do while keyFields <> ""
							fldName = hsh_ExtractItem(keyFields, "|")
							If fldName = "" Then
								Exit Do
							End If
							stPos = InStr(1, valueList, fldName)
							if stPos > 0 Then
								stPos = stPos - 1
								endPos = InStr(stPos, valueList, ")")
								if endPos > 0 Then
									if Len(keyCond(curKeyIdx)) > 0 Then
										keyCond(curKeyIdx) = keyCond(curKeyIdx) & " And "
									End If
									keyCond(curKeyIdx) = keyCond(curKeyIdx) & Mid(valueList, stPos, endPos - stPos + 1)
								'Else
								'	hshErrCode = 9
								'	hshErrDesc = "Syntax Error in GlobalVars specs: ***" & hshUniqueKeyFields(k) & " and " & valueList & "***"
								'	IsFound = False
								'	Exit Do
								End If
							'Else
							'	hshErrCode = 9
							'	hshErrDesc = "Syntax Error in GlobalVars specs: ***" & hshUniqueKeyFields(k) & " and " & valueList & "***"
							'	IsFound = False
							'	Exit Do
							End if
						Loop
						If keyCond(curKeyIdx) <> "" Then
							if strWhere <> "" Then
								strWhere = strWhere & " OR "
							End If
							strWhere = strWhere & keyCond(curKeyIdx)
							curKeyIdx = curKeyIdx + 1
						End If
					End If
				Next
				Exit For
			End If
		End If
	Next
	' Build SQL string
	If IsFound = True Then
		If Len(strWhere) > 0 Then
			sqlQry = sqlQry & " Where " & strWhere
			Set rs = Server.CreateObject("ADODB.Recordset")
			rs.Open sqlQry, dbConn
			if Not (rs.EOF Or rs.BOF) Then
				hshErrCode = 4
				hshErrDesc = "The Record in table {" & TableName & "} with condition [" & strWhere & "] will create duplicate key<br>Value List: " & valueList & "<br>"
				IsFound = False
			End If
			rs.close
			set rs = nothing
		End If
	End If
	IsUniqueKey = IsFound
	call hsh_CloseConnection(dbConn)

End Function

' ==============================================================================
' IsKeyField: Check wether the field is part of a key in the table or not
' ==============================================================================
Function IsKeyField(TableName, FieldName)
	Dim IsFound, i, k, fldCount, fldName, keyFields
	
	IsFound = 0
	for i = 0 to hshNumUKF - 1
		if Mid(hshUniqueKeyFields(i), 1, 1) = "*" then
			If Mid(hshUniqueKeyFields(i), 3) = TableName Then
				fldCount = CInt(Mid(hshUniqueKeyFields(i), 2, 1))
				for k = i + 1 to fldCount + i
					keyFields = hshUniqueKeyFields(k)
					Do while keyFields <> ""
						fldName = hsh_ExtractItem(keyFields, "|")
						If fldName = "" Then
							Exit Do
						End If
						if fldName = FieldName Then
							IsFound = k
							Exit Do
						End If
					Loop
				Next
			End If
		End If
	Next
	IsKeyField = IsFound
	
End Function
' ==============================================================================
' IsReadOnlyField: Check wether the field is a Read Only field in the table or not
' ==============================================================================
Function IsReadOnlyField(TableName, FieldName)
	Dim Default_value, i, k, fldCount, fldName, ReadOnlyFields

	Default_value = ""
	for i = 0 to hshNumROF - 1
		if Mid(hshReadOnlyFields(i), 1, 1) = "*" then
			If Mid(hshReadOnlyFields(i), 3) = TableName Then
				fldCount = CInt(Mid(hshReadOnlyFields(i), 2, 1))
				for k = i + 1 to fldCount + i
					ReadOnlyFields = hshReadOnlyFields(k)
					fldName = hsh_ExtractItem(ReadOnlyFields, "|")
					If fldName <> "" Then
						if fldName = FieldName Then
							Default_value = ReadOnlyFields
						End If
					End If
				Next
			End If
		End If
	Next
	IsReadOnlyField = Default_value
	
End Function
' ========================================================
Function hsh_ExtractItem(strList, sep)
	Dim pos, srcList, curItem
	' =========================================================
	' strList: List of Items; sep: separator character between items in list
	' strList returned with first item remove, if item not found it become sero length string
	' The function returns the item found or zero length string if item not found.
	' Ezzat A. Helal (eahelal@helalsoftware.net)
	' Last Update Date: 25/9/2004
	' ===========================================================
	srcList = LTrim(strList)
	curItem = ""
	If (Len(srcList) > 0) Then
		pos = InStr(1, srcList, sep)
		if pos > 0 Then
			curItem = Left(srcList, pos - 1)
			strList = LTrim(Mid(srcList, pos + 1))
		Else
			curItem = srcList
			strList = ""
		End If
	End If
	hsh_ExtractItem = curItem

End Function
' ===================================================================
' hshCreateSqlForLinkedTable: Creates the sql query for linked table.
' Return: the function returns sql that selects one record if strFieldValue
'	equals the value of the required record index (the first field assumed, 
'	or sql that selects all the records in the table
' ===================================================================
Function hshCreateSqlForLinkedTable(strTableName, strFieldValue)
	Dim i, IsFound, pos, sqlQry, value_list, value_Name, value_field, fields_count, OrderBy_field
	
	sqlQry = "Select "
	IsFound = False
	for i = 0 to hshNumLT - 1
		if Mid(hshLinkedTables(i), 1, 1) = "*" then
			If Mid(hshLinkedTables(i), 2) = strTableName Then
				value_list = hshLinkedTables(i + 2)
				value_Name = hsh_ExtractItem(value_list, "+")
				OrderBy_field = value_Name
				value_field = ""
				fields_count = 0
				Do While Len(value_Name) > 0
					fields_count = fields_count + 1
					If Len(value_field) > 0 Then
						value_field = value_field & " & "
					End If
					value_field = value_field & value_Name
					value_Name = hsh_ExtractItem(value_list, "+")
				Loop
				If fields_count > 1 Then
					value_field = "(" & value_field & ") As composit_field, " & OrderBy_field
				End If
				sqlQry = sqlQry & hshLinkedTables(i + 1) & ", " & value_field & " From [" & strTableName & "]"
				if strFieldValue <> "" Then
					sqlQry = sqlQry & " Where (" & hshLinkedTables(i + 1) & " = " & strFieldValue & ")"
				End If
				sqlQry = sqlQry & " Order By " & OrderBy_field
				'Response.Write(sqlQry)
				'sqlQry = ""
				isFound = True
				Exit For
			End If
		End If
	Next
	if IsFound = True Then
		hshCreateSqlForLinkedTable = sqlQry
	Else
		hshCreateSqlForLinkedTable = ""
	End If

End Function
' ===================================================================
Function Generate_Select_Link(TableName, FieldName, FieldValue)
	Dim lnkTableName, dbConn, sqlQry, rs, IsLinked, pos
	
	IsLinked = False
	lnkTableName = hshFindLinkedTable(TableName, FieldName)
	If lnkTableName <> "" Then  ' A linked Table Found
		' Find Fields of linked table
		Set dbConn = Server.CreateObject("ADODB.Connection")
		call hsh_OpenConnection(dbConn, database_name)
		sqlQry = hshCreateSqlForLinkedTable(lnkTableName, "")
		if sqlQry <> "" Then
			Set rs = Server.CreateObject("ADODB.Recordset")
			rs.Open sqlQry, dbConn
			if Not rs.eof Then
				Response.Write("<SELECT NAME='" & FieldName & "'>")
				Do until rs.eof
					Response.Write("<OPTION VALUE='" & rs.Fields(0) & "'")
					If FieldValue = rs.Fields(0) Then
						Response.Write(" selected")
					End If
					Response.Write(">" & rs.Fields(1).Value & "</OPTION>")
					rs.MoveNext
				Loop
				Response.Write("</SELECT>")
				IsLinked = True
			End If
			rs.close
			set rs = nothing
		End If
	Else
		pos = InStr(1,FieldName, "LNK")
		If pos <> 0 Then  ' Link Field
			lnkTableName = Left(FieldName, pos - 1)
			Set dbConn = Server.CreateObject("ADODB.Connection")
			call hsh_OpenConnection(dbConn, database_name)
			sqlQry = "Select " & lnkTableName & "ISN, " & lnkTableName & "Name From [" &  lnkTableName & "] Order By " & lnkTableName & "Name"
			Set rs = Server.CreateObject("ADODB.Recordset")
			rs.Open sqlQry, dbConn
			if Not rs.eof Then
				Response.Write("<SELECT NAME='" & FieldName & "'>")
				Do until rs.eof
					Response.Write("<OPTION VALUE='" & rs.Fields(0) & "'>" & rs.Fields(1).Value & "</OPTION>")
					rs.MoveNext
				Loop
				Response.Write("</SELECT>")
				IsLinked = True
			End If
			rs.close
			set rs = nothing
		End If
	End If
	Generate_Select_Link = IsLinked
	
End Function

' ==================================================================
' hshGetKeyFieldsList
' ==================================================================
Function hshGetKeyFieldsList(strTableName)
	Dim i, k, fldCount, fldName, tblKeys
	
	tblKeys = ""
	for i = 0 to hshNumUKF - 1
		if Mid(hshUniqueKeyFields(i), 1, 1) = "*" then
			If Mid(hshUniqueKeyFields(i), 3) = strTableName Then
				fldCount = CInt(Mid(hshUniqueKeyFields(i), 2, 1))
				for k = i + 1 to fldCount + i
					tblKeys = tblKeys & hshUniqueKeyFields(k) & "|"
				Next
			End If
		End If
	Next
	hshGetKeyFieldsList = tblKeys

End Function
' ========================================================================================
' getISN: Get new Internal Sequence Number for new record in table
' ========================================================================================
Function getISN(TableName, FieldName)
	Dim dbConn, sqlQry, rs, isn
	
	Set dbConn = Server.CreateObject("ADODB.Connection")
	call hsh_OpenConnection(dbConn, database_name)
	sqlQry = "Select Max(" & FieldName & ") As maxRecNo From [" & TableName & "]"
	Set rs = Server.CreateObject("ADODB.Recordset")
	rs.Open sqlQry, dbConn
	If rs.EOF Then
		isn = 1
	Else
		If IsNull(rs("maxRecNo")) Then
			isn = 1
	    Else
			isn = CLng(rs("maxRecNo")) + 1
	    End If
	End If
	rs.Close
	Set rs = Nothing
	getISN = isn
	call hsh_CloseConnection(dbConn)

End Function
' =====================================================================================
' hshDisplayRecords
' =====================================================================================
Function hshDisplayRecords(strTableName, strWhere)
	Dim dbConn, tblField, sqlQry, rs, x, recx, totRec, pos, lnkTableName, rsl
	Dim isLinked
	
	Set dbConn = Server.CreateObject("ADODB.Connection")
	call hsh_OpenConnection(dbConn, database_name)
	sqlQry = "Select * From [" &  strTableName & "]"
	if Len(strWhere) > 0 Then
		sqlQry = sqlQry & " Where " & strWhere
	End If
	Set rs = Server.CreateObject("ADODB.Recordset")
	rs.Open sqlQry, dbConn
	Response.Write("<b>List Records in table [" & strTableName & "]</b><br>")
	' Display records for selection
	Response.Write("<TABLE align=left border=1 cellpadding='2' cellspacing='2'>")
	Response.Write("<TR>")
	For each tblField in rs.fields
		If InStr(1,tblField.Name, "ISN") = 0 Then  ' Not Internal Sequence Number Field
			Response.Write("<TD align=left><b>" & tblField.name & "</b></TD>")
		End If
	Next
	Response.Write("</TR>")
	totRec = 0
	If rs.EOF Then
		Response.Write("<TR>")
		For each tblField in rs.Fields
			If InStr(1,tblField.Name, "ISN") = 0 Then  ' Not Internal Sequence Number Field
				Response.Write("<TD align=left>No Data</TD>")
			End If
		Next
		Response.Write("</TR>")
	Else
		recx = 1
		Do until rs.eof
			Response.Write("<TR>")
			for x = 0 to rs.fields.count - 1
				isLinked = False
				If InStr(1,rs.Fields(x).Name, "ISN") = 0 Then  ' Not Internal Sequence Number Field
					lnkTableName = hshFindLinkedTable(strTableName, rs.Fields(x).Name)
					If lnkTableName <> "" Then  ' A linked Table Found
						' Find Fields of linked table
						sqlQry = hshCreateSqlForLinkedTable(lnkTableName, rs.Fields(x).Value)
						if sqlQry <> "" Then
							Set rsl = Server.CreateObject("ADODB.Recordset")
							rsl.Open sqlQry, dbConn
							if Not rsl.eof Then
								Response.Write("<TD align=left>" & rsl.Fields(1).Value & "</TD>")
							End If
							rsl.close
							set rsl = nothing
							isLinked = True
						End If
					Else
						pos = InStr(1,rs.Fields(x).Name, "LNK")
						If pos <> 0 Then  ' Link Field
							lnkTableName = Left(rs.Fields(x).Name, pos - 1)
							sqlQry = "Select " & lnkTableName & "ISN, " & lnkTableName & "Name From [" &  lnkTableName & "]"
							sqlQry = sqlQry & " Where (" & lnkTableName & "ISN = " & rs.Fields(x).Value & ")"
							Set rsl = Server.CreateObject("ADODB.Recordset")
							rsl.Open sqlQry, dbConn
							if Not rsl.eof Then
								Response.Write("<TD align=left>" & rsl.Fields(1).Value & "</TD>")
							End If
							rsl.close
							set rsl = nothing
							isLinked = True
						End If
					End If
					If isLinked = False Then
						Response.Write("<TD align=left>" & rs.Fields(x).Value & "</TD>")
					End If
				End If
			Next
			Response.Write("</TR>")
			recx = recx + 1
			rs.movenext
		Loop
		totRec = recx - 1
	End If
	Response.Write("</TABLE>")
	rs.close
	set rs = nothing
	call hsh_CloseConnection(dbConn)

End Function

' =========================================================================
' Display Record Fields for addition
' =========================================================================
Function DisplayAddNewRecord(TableName)
	Dim dbConn, sqlQry, rs, TblField, pos, lnkTableName, rsl, IsLinked

	Set dbConn = Server.CreateObject("ADODB.Connection")
	call hsh_OpenConnection(dbConn, database_name)
	sqlQry = "Select * From [" &  TableName & "]"
	Set rs = Server.CreateObject("ADODB.Recordset")
	rs.Open sqlQry, dbConn
	' Generate Action Table
	Response.Write("<input type='Hidden' name='TableName' value='" & TableName & "'>")
	Response.Write("<table border=1 width='100'><tr>")
	Response.Write("<td width='33%' align=Center><input type='button' value='Add New Record' name='add_rec' onClick='javascript:Submit_Action(""ADD_REC"");'></td>")
	Response.Write("<td width='33%' align=Center><input type='reset' value='Reset' name='reset_data'></td>")
	Response.Write("<td width='34%' align=Center><input type='button' value='Back' name='cancel' onClick='javascript:Submit_Action(""CANCEL"");'></td>")
	Response.Write("</tr></table>")
	Response.Write("<br><center><big>Add New Data To The " & TableName & " Table</Big></Center><br>")
	' Set Table of fields
	Response.Write("<Table Width='100%' align=Left>")
	for each TblField in rs.Fields
		IsLinked = False
		If InStr(1,TblField.Name, "ISN") = 0 Then ' Not Internal Sequence Number Field
		If IsReadOnlyField(TableName, TblField.Name) = "" Then  
			Response.Write("<tr><td width='25%'>" & TblField.Name & "</td><td width='75%'>")
			IsLinked = generate_select_link(TableName, TblField.Name, "")
			If IsLinked = False Then
				If TblField.Type = adBoolean then
					Response.Write("<select size='1' name='" & TblField.Name & "'>")
					Response.Write("<option value='0'>False</option>")
					Response.Write("<option value='-1'>True</option>")
					Response.Write("</select>")
				ElseIf TblField.Type = adDate then
					Response.Write("<input type='text' maxLength='10' size='10' name='" & TblField.Name & "' onChange='javascript:if(objCalendar.ValidateDate(" & TblField.Name & ", """ & ted_date_format & """) < 3) this.form.reset();'> Format(" & ted_date_format & ")")
					Response.Write("<!-- popup calendar =================================================== -->")
					Response.Write("<a onClick='objCalendar.popUpCalendar(this, " & TblField.Name & ", """ & ted_date_format & """)'>")
					Response.Write("<img src=""images/btn_date.gif"" border=""0""></a>")
					Response.Write("<!-- ======================================================= popup calendar -->")
				ElseIf TblField.Type = adInteger Or TblField.Type = adSmallInt then
					Response.Write("<input type='text' maxLength='9' size='9' name='" & TblField.Name & "'>")
				ElseIf TblField.Type = advarWChar Then
					Response.Write("<input type='text' maxLength='" & TblField.DefinedSize & "' size='" & TblField.DefinedSize & "' name='" & TblField.Name & "'>")
					If ted_browse_image And TblField.Name = ImageFieldName(TableName) Then
	  					Response.Write("&nbsp;<img src='images/post_button_image.gif' align='absmiddle' border='0' title='Select Image' onClick=""javascript:Image_pallete('" & TblField.Name & "');"" style='cursor: pointer;'>")
						Response.Write("<iframe id='" & TblField.Name & "_SelectImage' src='TED_Select_Image.asp' width='435' height='250px' style='visibility:hidden; position: absolute; left: 0px; top: 0px;'></iframe>")
					End If
				ElseIf TblField.Type = AdlongVarWChar then
					Response.Write("<input type='text' maxLength='100' size='100' name='" & TblField.Name & "'>")
					If ted_browse_image And TblField.Name = ImageFieldName(TableName) Then
	  					Response.Write("&nbsp;<img src='images/post_button_image.gif' align='absmiddle' border='0' title='Select Image' onClick=""javascript:Image_pallete('" & TblField.Name & "');"" style='cursor: pointer;'>")
						Response.Write("<iframe id='" & TblField.Name & "_SelectImage' src='TED_Select_Image.asp' width='435' height='250px' style='visibility:hidden; position: absolute; left: 0px; top: 0px;'></iframe>")
					End If
				Else
					Response.Write("<input type='text' maxLength='15' size='15' name='" & TblField.Name & "'>")
				End If
			End If
			Response.Write("</td></tr>")
		End If
		End If
	Next
	Response.Write("</Table>")
	rs.close
	set rs = nothing
	call hsh_CloseConnection(dbConn)
End Function

' ========================================================================================
' AddNewRecord:
' ========================================================================================
Function AddNewRecord(TableName)
	Dim dbConn, sqlQry, rs, SQLInsert, SQLValues, tblField, isValid, RFieldValue, SqlAdd, AddCommand, FirstTime
	Dim isn, valueList, recISN
	
	hshErrCode = 0
	Set dbConn = Server.CreateObject("ADODB.Connection")
	call hsh_OpenConnection(dbConn, database_name)
	sqlQry = "Select * From [" &  TableName & "]"
	Set rs = Server.CreateObject("ADODB.Recordset")
	rs.Open sqlQry, dbConn

	set AddCommand = Server.CreateObject("ADODB.Command")
	AddCommand.ActiveConnection = dbConn
	SQLInsert = "Insert Into [" & TableName & "] ("
	SQLValues = ") VALUES ( "
	valueList = ""
	isValid = True
	FirstTime = True
	For each tblField in rs.Fields
		RFieldValue = Request.Form(tblField.name)
		If InStr(1,tblField.Name, "ISN") <> 0 Then  ' Internal Sequence Number Field
			isn = getISN(TableName, tblField.Name)
			If FirstTime Then
				SQLInsert = SQLInsert & tblField.name
				SQLValues = SQLValues & isn
				FirstTime = False
			Else
				SQLInsert = SQLInsert & " , " & tblField.name
				SQLValues = SQLValues & " , " & isn
			End If
		ElseIf RFieldValue <> "" Then
			' Validate Field and add to insert sql
			if tblField.Type = adDate Then
				if isdate(RFieldValue) = False then
					isValid = False
					hshErrCode = 3
					hshErrDesc = "This must be a valid Date {" & tblField.name & "}<br>"
				end if
			Elseif cbool(tblField.type = adBigInt) or cbool(tblField.type = adDecimal) or cbool(tblField.type = adDouble) or cbool(tblField.type = adInteger) then
				if IsNumeric(RFieldValue) = False then
					isValid = False
					hshErrCode = 3
					hshErrDesc = "This must be a numeric {" & tblField.name & "}<br>"
				end if
			End If  ' Check Field Type
			If isValid = True Then
				valueList = valueList & "(" & tblField.Name
				If FirstTime = False Then
					SQLInsert = SQLInsert & " , "
					SQLValues = SQLValues & " , "
				Else
					FirstTime = False
				End If
				SQLInsert = SQLInsert & tblField.name
				If TableName = "sponsorship" And tblField.name = "Orphan" Then
					recISN = RFieldValue
				End If
				' Create Appropriate SQL String Depending On Type Of Variable			
				If InStr(1,TblField.Name, "LNK") <> 0 Then  ' Link Field
					SQLValues = SQLValues & RFieldValue
					valueList = valueList & " = " & RFieldValue & ")"
				Elseif cbool(tblField.type = adVarChar) or cbool(tblField.type = adChar) or cbool(tblField.type = adWchar) then
					if RFieldValue = "" then
						SQLValues = SQLValues & "NULL"
					else
						SQLValues = SQLValues & "'" & cstr(RFieldValue) & "'"
						valueList = valueList & " = '" & RFieldValue & "')"
					end if
				ElseIf cbool(tblField.type = adBigInt) or cbool(tblField.type = adDecimal) or cbool(tblField.type = adDouble) or cbool(tblField.type = adInteger) then
					if RfieldValue = "" then
						SQLValues = SQLValues & "NULL"
					else
						SQLValues = SQLValues & RFieldValue
						valueList = valueList & " = " & RFieldValue & ")"
					end if
				ElseIf cbool(tblField.type = adBoolean) then
					if RfieldValue = "" then
						SQLValues = SQLValues & "NULL" 
					else
						SQLValues = SQLValues & cstr(RFieldValue)
						valueList = valueList & " = " & CStr(RFieldValue) & ")"
					end if
				ElseIf cbool(tblField.type = adDate) then
					if RfieldValue = "" then
						SQLValues = SQLValues & "NULL" 
					else
						SQLValues = SQLValues & CDbl(String_To_Date(RFieldValue, ted_date_format))
						valueList = valueList & " = " & CDbl(String_To_Date(RFieldValue, ted_date_format)) & ")"
					end if
				Else
					if RfieldValue = "" then
						SQLValues = SQLValues & "NULL"
					else
						SQLValues = SQLValues & "'" & cstr(RFieldValue) & "'"
						valueList = valueList & " = '" & RFieldValue & "')"
					end if
				end if
			End If
		Else ' newFieldValue = "" Then
			RFieldValue = IsReadOnlyField(TableName, tblField.Name)
			If RFieldValue <> "" Then
				If FirstTime = False Then
					SQLInsert = SQLInsert & " , "
					SQLValues = SQLValues & " , "
				Else
					FirstTime = False
				End If
				SQLInsert = SQLInsert & tblField.name
				If cbool(tblField.type = adDate) then
					SQLValues = SQLValues & CDbl(Now())
				ElseIf cbool(tblField.type = adBoolean) Or cbool(tblField.type = adBigInt) or cbool(tblField.type = adDecimal) or cbool(tblField.type = adDouble) or cbool(tblField.type = adInteger) then
					SQLValues = SQLValues & RFieldValue
				Else
					SQLValues = SQLValues & "'" & RFieldValue & "'"
				End If
			ElseIf IsKeyField(TableName, tblField.Name) > 0 Then
				hshErrCode = 5
				hshErrDesc = "Key Field [" & tblField.Name & "] Can not be NULL in table {" & TableName & "}<br>"
			End If
		End If  ' Field is entered
	Next
	rs.close
	set rs = nothing
	If hshErrCode = 0 Then
		If IsUniqueKey(TableName, ValueList, "") = True Then
			SqlAdd = SQLInsert & SqlValues & ")"
			'Response.Write(SqlAdd & "<br>")
			dbConn.BeginTrans
			AddCommand.CommandText = SqlAdd
			AddCommand.Execute
			dbConn.CommitTrans
			call hsh_After_Update(TableName, 0, recISN)
		Else
			hshErrDesc = "Error in Addition of new record - " & hshErrDesc
		End If
	End If
	If dbConn.Errors.Count <> 0 then
		hshErrCode = 6
		hshErrDesc = dbConn.Errors.Item(0)
	End If
	call hsh_CloseConnection(dbConn)

End Function

' ===========================================================
' Select record
' ===========================================================
Function hshSelectRecord(TableName, strWhere, IsEdit)
	Dim dbConn, tblField, sqlQry, rs, x, recx, totRec, pos, lnkTableName, rsl, tblKeyList, strCnd
	Dim isLinked, isn_field_name
	
	Set dbConn = Server.CreateObject("ADODB.Connection")
	call hsh_OpenConnection(dbConn, database_name)
	sqlQry = "Select * From [" &  TableName & "]"
	if Len(strWhere) > 0 Then
		sqlQry = sqlQry & " Where " & strWhere
	End If
	Set rs = Server.CreateObject("ADODB.Recordset")
	rs.Open sqlQry, dbConn
	Session.Contents("STR") = ""
	Response.Write("<table><tr><td>")
	Response.Write("<b>Select Records in table [" & TableName & "]</b></td></tr><tr><td>")
	Response.Write("<input type='hidden' name='TableName' value='" & TableName & "'>")
	Response.Write("<input type='hidden' name='selCnd' value='" & strWhere & "'>")
	Response.Write("<input type='hidden' name='edMode' value='0'>")
	' Display records for selection
	Response.Write("<TABLE align=left border=1 cellpadding='2' cellspacing='2'>")
	Response.Write("<TR><TD align=center><b>Select Record</b></TD>")
	isn_field_name = ""
	For each tblField in rs.fields
		If InStr(1,tblField.Name, "ISN") <> 0 Then  ' Internal Sequence Number Field
			isn_field_name = tblField.name
		End If
		Response.Write("<TD align=left><b>" & tblField.name & "</b></TD>")
	Next
	Response.Write("</TR>")
	totRec = 0
	If rs.EOF Then
		Response.Write("<TR><TD align=center>No Data</TD>")
		For each tblField in rs.Fields
			Response.Write("<TD align=left>No Data</TD>")
		Next
		Response.Write("</TR>")
	Else
		recx = 1
		Do until rs.eof
			Response.Write("<TR><TD align=center><input type='checkbox' name='keyField' value='" & rs.Fields(isn_field_name).Value & "'></TD>")
			for x = 0 to rs.fields.count - 1
				isLinked = False
				'If InStr(1,rs.Fields(x).Name, "ISN") = 0 Then  ' Not Internal Sequence Number Field
					lnkTableName = hshFindLinkedTable(TableName, rs.Fields(x).Name)
					If lnkTableName <> "" Then  ' A linked Table Found
						' Find Fields of linked table
						sqlQry = hshCreateSqlForLinkedTable(lnkTableName, rs.Fields(x).Value)
						if sqlQry <> "" Then
							Set rsl = Server.CreateObject("ADODB.Recordset")
							rsl.Open sqlQry, dbConn
							if Not rsl.eof Then
								Response.Write("<TD align=left>" & rsl.Fields(1).Value & "</TD>")
							End If
							rsl.close
							set rsl = nothing
							isLinked = True
						End If
					Else
						pos = InStr(1,rs.Fields(x).Name, "LNK")
						If pos <> 0 Then  ' Link Field
							lnkTableName = Left(rs.Fields(x).Name, pos - 1)
							sqlQry = "Select " & lnkTableName & "ISN, " & lnkTableName & "Name From [" &  lnkTableName & "]"
							sqlQry = sqlQry & " Where (" & lnkTableName & "ISN = " & rs.Fields(x).Value & ")"
							Set rsl = Server.CreateObject("ADODB.Recordset")
							rsl.Open sqlQry, dbConn
							if rsl.eof Then
								Response.Write("<TD align=left>" & rs.Fields(x).Value & "</TD>")
							Else
								Response.Write("<TD align=left>" & rsl.Fields(1).Value & "</TD>")
							End If
							rsl.close
							set rsl = nothing
							isLinked = True
						End If
					End If
					If isLinked = False Then
						If rs.Fields(x).Type = adDate then
							Response.Write("<TD align=left>" & Date_To_String(rs.Fields(x).Value, ted_date_format) & "</TD>")
						Else
							Response.Write("<TD align=left>" & rs.Fields(x).Value & "</TD>")
						End If
					End If
				'End If
			Next
			Response.Write("</TR>")
			recx = recx + 1
			rs.movenext
		Loop
		totRec = recx - 1
	End If
	Response.Write("</TABLE></td></tr><tr><td>")
	Response.Write("<input type='hidden' name='totrec' value='" & totRec & "'>")
	If IsEdit = True Then
		Response.Write("<INPUT name='edit' type='button' value='Edit' onClick='javascript:Submit_Action(""EDIT_REC"");'>")
	Else
		Response.Write("<INPUT name='delete' type='button' value='Delete' onClick='javascript:Submit_Action(""DELETE_REC"");'>")
	End If
	Response.Write("<INPUT name='cancel' type='button' value='Back' onClick='javascript:Submit_Action(""CANCEL"");'>")
	Response.Write("</td></tr></table>")
	rs.close
	set rs = nothing
	call hsh_CloseConnection(dbConn)

End Function
' ==========================================================================
Function hshExtractRecord(TableName, action)
	Dim dbConn, sqlQry, rs, key_fields, recISN, isn_field_name, tblField, strWhere, more
	
	Set dbConn = Server.CreateObject("ADODB.Connection")
	call hsh_OpenConnection(dbConn, database_name)
	sqlQry = "Select * From [" &  TableName	& "]"
	Set rs = Server.CreateObject("ADODB.Recordset")
	rs.Open sqlQry, dbConn
	strWhere = ""
	If rs.EOF Or rs.BOF Then
		Response.Write("<b>No Records Found in Table " & TableName & "</b><br>")
	Else
		key_fields = Request.Form("keyField")
		recISN = hsh_ExtractItem(key_fields, ",")
		If recISN <> "" Then
			isn_field_name = ""
			For each tblField in rs.fields
				If InStr(1,tblField.Name, "ISN") <> 0 Then  ' Internal Sequence Number Field
					isn_field_name = tblField.name
					Exit For
				End If
			Next
			If isn_field_name <> "" Then
				strWhere = "(" & isn_field_name & " = " & recISN & ")"
			End If
		End If
	End If
	rs.close
	set rs = nothing
	call hsh_CloseConnection(dbConn)
	If strWhere <> "" Then
		If key_fields = "" Then
			more = False
		Else
			more = True
		End If
		Response.Write("<input type='hidden' name='selCnd' value='" & strWhere & "'>")
		Response.Write("<input type='hidden' name='keyField' value='" & key_fields & "'></TD>")
		Response.Write("<input type='Hidden' name='TableName' value='" & TableName &"'>")
		If action = "EDIT_REC" Or actCode = "CANCEL_UPDATE" Then
			call hshDisplayEditRecord(TableName, strWhere, more)
		End If
	Else
		ShowAdminMenu
	End If
	
End Function
' =========================================================================
' Display Record For Edit
' =========================================================================
Function hshDisplayEditRecord(TableName, strWhere, more)
	Dim dbConn, tblField, sqlQry, rs, rSeq, recFound, pos, lnkTableName, rsl, IsLinked
	
	Set dbConn = Server.CreateObject("ADODB.Connection")
	call hsh_OpenConnection(dbConn, database_name)
	sqlQry = "Select * From [" &  TableName & "] Where " & strWhere
	Set rs = Server.CreateObject("ADODB.Recordset")
	rs.Open sqlQry, dbConn

	If rs.EOF Or rs.BOF Then
		Response.Write("<b>No Records Found in Table " & TableName & "</b><br>")
		hshErrCode = 1
		Exit Function
	End If
	hshErrCode = 0
		Response.Write("<br><center><big>Update This Record in table [" & TableName & "]</Big></Center><br>")
		Response.Write("<Table Width=800 align=Left>")
		for each TblField in rs.Fields
			Response.Write("<tr><td width=200>" & TblField.Name & "</td><td width='75%'>")
			If InStr(1,TblField.Name, "ISN") <> 0 Or IsReadOnlyField(TableName, TblField.Name) <> "" Then ' Internal Sequence Number Field
				Response.Write(rs.Fields(tblField.Name) & "</td></tr>")
			Else
				IsLinked = Generate_Select_Link(TableName, tblField.Name, rs.Fields(tblField.Name))
				If IsLinked = False Then
					if TblField.Type = adBoolean then
						Response.Write("<select size='1' name='" & TblField.Name & "'>")
						if rs.Fields(tblField.Name) Then
							Response.Write("<option value='0'>False</option>")
							Response.Write("<option value='-1' selected>True</option>")
						Else
							Response.Write("<option value='0' selected>False</option>")
							Response.Write("<option value='-1'>True</option>")
						End If
						Response.Write("</select>")
					ElseIf TblField.Type = adDate then
						Response.Write("<input type='text' maxLength='10' size='10' name='" & TblField.Name & "' value='" & Date_To_String(rs.Fields(tblField.Name), ted_date_format) & "' onChange='javascript:if(objCalendar.ValidateDate(" & TblField.Name & ", """ & ted_date_format & """) < 3) this.form.reset();'> Format(" & ted_date_format & ")")
						Response.Write("<!-- popup calendar =================================================== -->")
						Response.Write("<a onClick='objCalendar.popUpCalendar(this, " & TblField.Name & ", """ & ted_date_format & """)'>")
						Response.Write("<img src=""images/btn_date.gif"" border=""0""></a>")
						Response.Write("<!-- ======================================================= popup calendar -->")
					ElseIf TblField.Type = adInteger Or TblField.Type = adSmallInt then
						Response.Write("<input type='text' maxLength='9' size='9' name='" & TblField.Name & "' value='" & rs.Fields(tblField.Name) & "'>")
					ElseIf TblField.Type = advarWChar Then
						Response.Write("<input type='text' maxLength='" & TblField.DefinedSize & "' size='" & TblField.DefinedSize & "' name='" & TblField.Name & "' value='" & rs.Fields(tblField.Name) & "'>")
						If ted_browse_image And TblField.Name = ImageFieldName(TableName) Then
	  						Response.Write("&nbsp;<img src='images/post_button_image.gif' align='absmiddle' border='0' title='Select Image' onClick=""javascript:Image_pallete('" & TblField.Name & "');"" style='cursor: pointer;'>")
							Response.Write("<iframe id='" & TblField.Name & "_SelectImage' src='TED_Select_Image.asp' width='435' height='250px' style='visibility:hidden; position: absolute; left: 0px; top: 0px;'></iframe>")
						End If
					ElseIf TblField.Type = AdlongVarWChar then
						If ted_browse_image And TblField.Name = ImageFieldName(TableName) Then
	  						Response.Write("&nbsp;<img src='images/post_button_image.gif' align='absmiddle' border='0' title='Select Image' onClick=""javascript:Image_pallete('" & TblField.Name & "');"" style='cursor: pointer;'>")
							Response.Write("<iframe id='" & TblField.Name & "_SelectImage' src='TED_Select_Image.asp' width='435' height='250px' style='visibility:hidden; position: absolute; left: 0px; top: 0px;'></iframe>")
						End If
						Response.Write("<input type='text' maxLength='100' size='100' name='" & TblField.Name & "' value='" & rs.Fields(tblField.Name) & "'>")
					Else
						Response.Write("<input type='text' maxLength='15' size='15' name='" & TblField.Name & "' value='" & rs.Fields(tblField.Name) & "'>")
					End If
					Response.Write("</td></tr>")
				End If ' Not Linked Field
			End If ' Not Internal Sequence Number Field
		Next
		Response.Write("<tr><td colSpan=2><table border='1' width='100%'><tr>")
		Response.Write("<td width='25%' align=Center><input type='button' value='Update Record' name='update_record' onClick='javascript:Submit_Action(""UPDATE_REC"");'></td>")
		Response.Write("<td width='25%' align=Center>")
		If more Then
			Response.Write("<input type='button' value='Cancel Update' name='cancel_update' onClick='javascript:Submit_Action(""CANCEL_UPDATE"");'></td>")
		Else
			Response.Write("NO MORE RECORDS</td>")
		End If
		Response.Write("<td width='25%' align=Center><input type='reset' value='Reset' name='B2'></td>")
		Response.Write("<td width='25%' align=Center><input type='button' value='Back' name='cancel' onClick='javascript:Submit_Action(""CANCEL"");'></td></tr>")
		Response.Write("</table></td></tr>")
		Response.Write("</Table>")
	rs.close
	set rs = nothing
	call hsh_CloseConnection(dbConn)

End Function

' ===================================================================================
' Update Record
' ===================================================================================
Function hshUpdateSelectedRecord(TableName, strWhereCnd)
	Dim dbConn, tblField, sqlQry, rs, rSeq, recFound, SQLUpdate, FirstTime, strWhere, x, KeywordFound
	Dim newFieldValue, cmd, IsFieldChanged, IsKeyChanged, valueList, all_valueList, k, recISN, oldISN, orphanISN
	
	Set dbConn = Server.CreateObject("ADODB.Connection")
	call hsh_OpenConnection(dbConn, database_name)
	sqlQry = "Select * From [" &  TableName & "] Where " & strWhereCnd
	Set rs = Server.CreateObject("ADODB.Recordset")
	rs.Open sqlQry, dbConn

	If rs.EOF Or rs.BOF Then
		hshErrDesc = "<b>No Records Found in Table " & TableName & "</b><br>"
		hshErrCode = 1
		rs.close
		set rs = nothing
		call hsh_CloseConnection(dbConn)
		Exit Function
	End If
	If TableName = "sponsorship" Then
		oldISN = CLng(rs("Orphan"))
	Else
		oldISN = 0
	End If
	hshErrCode = 0
	SQLUpdate = "Update [" & TableName & "] "
	strWhere = ""
	FirstTime = true
	IsKeyChanged = ""
	valueList = ""
	for each tblField in rs.Fields
		IsFieldChanged = False
		If InStr(1,tblField.Name, "ISN") <> 0 Then  ' Internal Sequence Number Field
			recISN = CLng(tblField.Value)
			strWhere = " Where (" & tblField.Name & "=" & tblField.Value & ")"
		Else
			If IsReadOnlyField(TableName, tblField.Name) = "" Then
			newFieldValue = Request.Form(tblField.name)
			If TableName = "sponsorship" And tblField.Name = "Orphan" Then
				if newFieldValue <> "" then
					orphanISN = CLng(newFieldValue)
				Else
					orphanISN = 0
				End If
			End If
			If FirstTime = False Then
				SQLUpdate = SQLUpdate & " , "
			Else
				SQLUpdate = SQLUpdate & "SET"
				FirstTime = False
			End If
			' Add Field Name to SQLUpdate ===========================
			KeywordFound = False
			for x = 0 to NumKeywords - 1
				if tblField.name = Keywords(x) then
					KeywordFound = True
					exit for
				end if
			next
			if KeywordFound then
				SQLUpdate = SQLUpdate & " [" & tblField.name & "] = "
			else
				SQLUpdate = SQLUpdate & " " & tblField.name & " = "
			end if
			' Validate Field and add to SQLUpdate
			' =============================================
			if cbool(tblField.type = adVarChar) or cbool(tblField.type = adChar) or cbool(tblField.type = adWchar) then
				if newFieldValue = "" then
					SQLUpdate = SQLUpdate & " NULL "
				else
					SQLUpdate = SQLUpdate & " '" & newFieldValue & "' "
					If newFieldValue <> tblField.Value Then
						IsFieldChanged = True
						valueList = valueList & "(" & tblField.Name & " = '" & newFieldValue & "')"
						all_valueList = all_valueList & "(" & tblField.Name & " = '" & newFieldValue & "')"
					Else
						all_valueList = all_valueList & "(" & tblField.Name & " = '" & tblField.value & "')"
					End If
				end if
			elseif cbool(tblField.type = adBigInt) or cbool(tblField.type = adDecimal) or cbool(tblField.type = adDouble) or cbool(tblField.type = adInteger) then
				if newFieldValue = "" then
					SQLUpdate = SQLUpdate & " NULL "
				else
					if IsNumeric(newFieldValue) = False then
						hshErrCode = 3
						hshErrDesc = "This must be numeric { " & tblField.name & " }"
					Else
						SQLUpdate = SQLUpdate & " " & newFieldValue & " "
						If newFieldValue <> CStr(tblField.Value) Then
							IsFieldChanged = True
							valueList = valueList & "(" & tblField.Name & " = " & newFieldValue & ")"
							all_valueList = all_valueList & "(" & tblField.Name & " = " & newFieldValue & ")"
						Else
							all_valueList = all_valueList & "(" & tblField.Name & " = " & tblField.value & ")"
						End If
					end if
				end if
			elseif cbool(tblField.type = adBoolean) then
				if newFieldValue = "" then
					SQLUpdate = SQLUpdate & " NULL "
				else
					SQLUpdate = SQLUpdate & " " & newFieldValue & " "
					If CInt(newFieldValue) <> CInt(tblField.Value) Then
						IsFieldChanged = True
						valueList = valueList & "(" & tblField.Name & " = " & newFieldValue & ")"
					End If
				end if
			else
				if newFieldValue = "" then
					SQLUpdate = SQLUpdate & " NULL "
				else
					if tblField.Type = adDate Then
						if isdate(Request.form(tblField.name)) = False then
							hshErrCode = 3
							hshErrDesc = "This must be a valid Date { " & tblField.name & " }"
						Else
							SQLUpdate = SQLUpdate & " " & cdbl(String_To_Date(newFieldValue, ted_date_format)) & " "
							If newFieldValue <> CStr(tblField.Value) Then
								IsFieldChanged = True
								valueList = valueList & "(" & tblField.Name & " = '" & newFieldValue & "')"
								all_valueList = all_valueList & "(" & tblField.Name & " = " & cdbl(String_To_Date(newFieldValue, ted_date_format)) & ")"
							Else
								all_valueList = all_valueList & "(" & tblField.Name & " = " & cdbl(cdate(tblField.value)) & ")"
							End If
						End If
					Else
						If IsNull(tblField.Value) Then
							IsFieldChanged = True
							valueList = valueList & "(" & tblField.Name & " = '" & newFieldValue & "')"
							all_valueList = all_valueList & "(" & tblField.Name & " = '" & newFieldValue & "')"
						ElseIf CStr(newFieldValue) <> CStr(tblField.Value) Then
							IsFieldChanged = True
							valueList = valueList & "(" & tblField.Name & " = '" & newFieldValue & "')"
							all_valueList = all_valueList & "(" & tblField.Name & " = '" & newFieldValue & "')"
						Else
							all_valueList = all_valueList & "(" & tblField.Name & " = '" & tblField.value & "')"
						End If
						SQLUpdate = SQLUpdate & " '" & cstr(newFieldValue) & "' "
					end if
				end if
			end if
			If newFieldValue = "" Then
				If IsKeyField(TableName, tblField.Name) = True Then
					hshErrCode = 5
					hshErrDesc = "Key Field [" & tblField.Name & "] Can not be NULL in table {" & TableName & "}<br>"
				End If
			End If
			If IsFieldChanged = True Then
				k = IsKeyField(TableName, tblField.Name)
				If k > 0 And IsKeyChanged <> "" Then
					IsKeyChanged = IsKeyChanged & ","
				End If
				If k > 0 Then
					IsKeyChanged = IsKeyChanged & k
				End If
			End If
			End If ' Read Only Field
		End If
	Next
	if hshErrCode = 0 Then
		If IsKeyChanged <> "" Then
			If IsUniqueKey(TableName, all_valueList, IsKeyChanged) = False Then
				hshErrDesc = "Error in Updating record - " & hshErrDesc
			End If
		End If
		if hshErrCode = 0 Then
			' Update the record
			dbConn.BeginTrans
			set cmd = Server.CreateObject("ADODB.Command")
   			'dbConn.LockType = adLockBatchOptimistic
			cmd.ActiveConnection = dbConn
			SqlUpdate = SqlUpdate & strWhere
			'Response.Write("SQL: " & sqlUpdate & "<br>")
			cmd.CommandText = SqlUpdate
			cmd.Execute
			dbConn.CommitTrans
			call hsh_After_Update(TableName, oldISN, orphanISN)
		End If
	End If
	If dbConn.Errors.Count <> 0 then
		hshErrCode = 6
		hshErrDesc = dbConn.Errors.Item(0)
	End If
	rs.close
	set rs = nothing
	call hsh_CloseConnection(dbConn)

End Function

' =====================================================================
Function hshEstablishWhereCnd(tblKeyList, rs, whereCnd)
	Dim tblField, strCnd, isNew, isFound
	
	strCnd = whereCnd & "("
	IsNew = True
	isFound = False
	For each tblField in rs.Fields
		if InStr(1, tblKeyList, tblField.Name) Then
			isFound = True
			if isNew = False Then
				strCnd = strCnd & " And "
			End If
			isNew = False
			strCnd = strCnd & "([" & tblField.Name & "]"
			if cbool(tblField.type = adVarChar) or cbool(tblField.type = adChar) or cbool(tblField.type = adWchar) then
				' Strin Field
				strCnd = strCnd & " = '" & rs(tblField.Name).Value & "')"
			elseif cbool(tblField.type = adBigInt) or cbool(tblField.type = adDecimal) or cbool(tblField.type = adDouble) or cbool(tblField.type = adInteger) then
				' Numeric Field
				strCnd = strCnd & " = " & rs(tblField.Name).Value & ")"
			elseif cbool(tblField.type = adBoolean) then
				' Boolean Field
				if CInt(rs(tblField.Name).Value) <> 0 Then
					strCnd = strCnd & " <> 0)"
				Else
					strCnd = strCnd & " = 0)"
				End If
			elseif tblField.Type = adDate Then
				' date Field
				strCnd = strCnd & " = " & CDbl(CDate(rs(tblField.Name).Value)) & ")"
			Else ' Other fields
				strCnd = strCnd & " = '" & rs(tblField.Name).Value & "')"
			End If
		End If
	Next
	strCnd = strCnd & ")"
	if isFound = True Then
		hshEstablishWhereCnd = strCnd
	Else
		hshEstablishWhereCnd = ""
	End If
	
End Function

' ================================================================
' Delete Selected Records: Checkbox contains the key fields list if selected
' =================================================================
Function hshDeleteSelectedRecords(TableName)
	Dim dbConn, tblField, sqlQry, rs, key_fields, strWhere, cmd, recx, SQLDelete
	
	key_fields = Request.Form("keyField")
	If key_fields = "" Then
		hshErrDesc = "<b>No records selected for deletion<b>"
		hshErrCode = 7
		hshDeleteSelectedRecords = 0
		Exit Function
	End If
	hshErrCode = 0
	strWhere = ""
	Set dbConn = Server.CreateObject("ADODB.Connection")
	call hsh_OpenConnection(dbConn, database_name)
	sqlQry = "Select * From [" &  TableName	& "]"
	Set rs = Server.CreateObject("ADODB.Recordset")
	rs.Open sqlQry, dbConn
	If rs.EOF Or rs.BOF Then
		hshErrDesc = "<b>No Records Found in Table " & TableName & "</b><br>"
		hshErrCode = 1
		rs.close
		set rs = nothing
		call hsh_CloseConnection(dbConn)
		hshDeleteSelectedRecords = 0
		Exit Function
	Else
		for each tblField in rs.Fields
			If InStr(1,tblField.Name, "ISN") <> 0 Then  ' Internal Sequence Number Field
				strWhere = " Where (" & tblField.Name & " IN (" & key_fields & "))"
				Exit For
			End If
		Next
	End If
	rs.close
	set rs = nothing

	If strWhere = "" Then
		hshErrDesc = "<b>No ISN field found in Records specifications of table: " & TableName & "<b>"
		hshErrCode = 8
		hshDeleteSelectedRecords = 0
		Exit Function
	End If

	sqlQry = "Select * From [" &  TableName	& "]" & strWhere
	Set rs = Server.CreateObject("ADODB.Recordset")
	rs.Open sqlQry, dbConn
	recx = 0
	Do until rs.eof
		call hshOnDelete(TableName, rs)
		recx = recx + 1
		rs.movenext
	Loop
	rs.close
	set rs = nothing

	if recx > 0 Then
		' Delete the record
		SQLDelete = "Delete From [" & TableName & "]" & strWhere
		'Response.Write("Delete SQL: " & SQLDelete & "<br>")
		set cmd = Server.CreateObject("ADODB.Command")
		cmd.ActiveConnection = dbConn
		cmd.CommandText = SQLDelete
		cmd.Execute 
	End If
	call hsh_CloseConnection(dbConn)
	hshDeleteSelectedRecords = recx
	
End Function

%>
